import datetime
import time

from django.http import HttpResponse

from tkschedule.emails import EmailManager
from .models import ReservIndex
from .tasks import testEmail
# Create your views here.
import logging

logger = logging.getLogger("tkschedule.views")
MAIL_CONf = {
    'msg_from': 'trialmold@tkmold.com',
    'password': '123456',
    # 'msg_from': 'solitary02@163.com',
    # 'password': 'ZGHKSEWBQSMUNGBS',
    # 'msg_to': ['trialmold@tkmold.com'],
    'msg_to': ['1621582331@tkmold.com'],
    'msg_subject': '试模约机确认提醒(请勿回复本邮件)！',
    'msg_content': 'No Content!',
    'attach_file': r'',
    'msg_date': time.ctime()
}

def testDatabase():
    dt_s = datetime.datetime.now().date()
    dt_e = (dt_s + datetime.timedelta(3))
    objs = ReservIndex.objects.filter(r_trialdate__range=[dt_e, dt_e]).values('r_tag', 'r_trialdate',
                                                                              'r_mold_no', 'r_trial_no',
                                                                              'reservextra__r_make_engineer',
                                                                              'reservextra__r_mk_email')
    logger.info(objs.count())
    logger.info(objs)


def getData():

    email_manager = EmailManager(**MAIL_CONf)

    dt_s = datetime.datetime.now().date()
    dt_e = (dt_s + datetime.timedelta(3))
    objs = ReservIndex.objects.filter(r_trialdate__range=[dt_e, dt_e]).values('r_tag','r_trialdate',
                                                                              'r_mold_no','r_trial_no',
                                                                              'reservextra__r_make_engineer',
                                                                              'reservextra__r_mk_email')
    count = objs.count()
    if count != 0 :
        for item in objs:
            mk_email  = item['reservextra__r_mk_email']
            if mk_email == 'N/A':
                logger.info("无邮件地址！")
                continue
            logger.info("无邮件地址！")
            mold_no = item['r_mold_no']
            trial_no = item['r_trial_no']
            trial_date = item['r_trialdate']
            msg_content = f"您预约的{mold_no}-{trial_no}试模将于{trial_date}进行，请前往试模系统进行确认！（若无预约请勿略此邮件。）"

            email_manager.set_msg_content(msg_content)
            email_manager.set_msg_to([mk_email])
            email_manager.send()
            # continue

def index(request):
    # getData()
    # logger.info("ss")
    # testDatabase()
    testEmail()

    return HttpResponse("Hello, world. You're at the polls index.")


